## girara 0.2.2

=== Makefile ===
# See LICENSE file for license and copyright information

include config.mk
include common.mk
include colors.mk

PROJECTNV = girara
PROJECT   = girara-gtk3
SOURCE    = $(wildcard *.c)
CSOURCE   = $(filter-out css-definitions.c, $(SOURCE))
OBJECTS   = ${CSOURCE:.c=.o} css-definitions.o
DOBJECTS  = ${OBJECTS:.o=.do}
GCDA      = ${SOURCE:.c=.gcda}
GCNO      = ${SOURCE:.c=.gcno}
HEADERS   = $(filter-out version.h,$(filter-out internal.h,$(wildcard *.h)))
HEADERS_INSTALL = ${HEADERS} version.h

ifneq (${WITH_LIBNOTIFY},0)
INCS += $(LIBNOTIFY_INC)
LIBS += $(LIBNOTIFY_LIB)
CPPFLAGS += -DWITH_LIBNOTIFY
LIBNOTIFY_PC_NAME = libnotify
else
LIBNOTIFY_PC_NAME =
endif

ifeq (,$(findstring -DGETTEXT_PACKAGE,${CPPFLAGS}))
CPPFLAGS += -DGETTEXT_PACKAGE=\"${GETTEXT_PACKAGE}\"
endif
ifeq (,$(findstring -DLOCALEDIR,${CPPFLAGS}))
CPPFLAGS += -DLOCALEDIR=\"${LOCALEDIR}\"
endif


all: ${PROJECT} po ${PROJECT}.pc

# pkg-config based version checks
.version-checks/%: config.mk
	$(QUIET)test $($(*)_VERSION_CHECK) -eq 0 || \
		pkg-config --atleast-version $($(*)_MIN_VERSION) $($(*)_PKG_CONFIG_NAME) || ( \
		echo "The minium required version of $(*) is $($(*)_MIN_VERSION)" && \
		false \
	)
	@mkdir -p .version-checks
	$(QUIET)touch $@

options:
	@echo ${PROJECT} build options:
	@echo "CFLAGS  = ${CFLAGS}"
	@echo "LDFLAGS = ${LDFLAGS}"
	@echo "DFLAGS  = ${DFLAGS}"
	@echo "CC      = ${CC}"

version.h: version.h.in config.mk
	$(QUIET)sed -e 's,@GVMAJOR@,${GIRARA_VERSION_MAJOR},' \
		-e 's,@GVMINOR@,${GIRARA_VERSION_MINOR},' \
		-e 's,@GVREV@,${GIRARA_VERSION_REV},' \
		version.h.in > version.h.tmp
	$(QUIET)mv version.h.tmp version.h

css-definitions.c: data/girara.css_t
	$(QUIET)echo '#include "css-definitions.h"' > $@.tmp
	$(QUIET)echo 'const char* CSS_TEMPLATE =' >> $@.tmp
	$(QUIET)sed 's/^\(.*\)$$/"\1\\n"/' $< >> $@.tmp
	$(QUIET)echo ';' >> $@.tmp
	$(QUIET)mv $@.tmp $@

%.o: %.c
	@mkdir -p .depend
	$(call colorecho,CC,$<)
	$(QUIET)${CC} -c ${CPPFLAGS} ${CFLAGS} -o $@ $< -MMD -MF .depend/$@.dep

%.do: %.c
	@mkdir -p .depend
	$(call colorecho,CC,$<)
	$(QUIET)${CC} -c ${CPPFLAGS} ${CFLAGS} ${DFLAGS} -o $@ $< -MMD -MF .depend/$@.dep

${OBJECTS} ${DOBJECTS}: config.mk version.h \
	.version-checks/GTK .version-checks/GLIB

${PROJECT}: static shared
static: lib${PROJECT}.a
shared: lib${PROJECT}.so.${SOVERSION}

lib${PROJECT}.a: ${OBJECTS}
	$(call colorecho,AR,$@)
	$(QUIET)ar rcs $@ ${OBJECTS}

lib${PROJECT}.so.${SOVERSION}: ${OBJECTS}
	$(call colorecho,LD,$@)
	$(QUIET)${CC} -Wl,-soname,lib${PROJECT}.so.${SOMAJOR} -shared ${LDFLAGS} -o $@ ${OBJECTS} ${LIBS}

clean:
	$(QUIET)rm -rf \
		${OBJECTS} \
		${DOBJECTS} \
		${TARFILE} \
		${TARDIR} \
		lib${PROJECT}.a \
		lib${PROJECT}-debug.a \
		${PROJECT}.pc \
		doc \
		lib$(PROJECT).so.${SOVERSION} \
		lib${PROJECT}-debug.so.${SOVERSION} \
		.depend \
		version.h \
		${GCDA} \
		${GCNO} \
		$(PROJECT).info \
		gcov \
		.version-checks \
		version.h.tmp \
		${PROJECT}.pc.tmp \
		css-definitions.c \
		css-definitions.c.tmp
	$(QUIET)${MAKE} -C tests clean
	$(QUIET)${MAKE} -C po clean

${PROJECT}-debug: lib${PROJECT}-debug.a lib${PROJECT}-debug.so.${SOVERSION}

lib${PROJECT}-debug.a: ${DOBJECTS}
	$(call colorecho,AR,$@)
	$(QUIET)ar rc $@ ${DOBJECTS}

lib${PROJECT}-debug.so.${SOVERSION}: ${DOBJECTS}
	$(call colorecho,LD,$@)
	$(QUIET)${CC} -Wl,-soname,lib${PROJECT}.so.${SOMAJOR} -shared ${LDFLAGS} -o $@ ${DOBJECTS} ${LIBS}

debug: options ${PROJECT}-debug

doc:
	$(QUIET)doxygen Doxyfile

gcov: clean
	$(QUIET)CFLAGS="${CFLAGS} -fprofile-arcs -ftest-coverage" LDFLAGS="${LDFLAGS} -fprofile-arcs" ${MAKE} $(PROJECT)
	$(QUIET)CFLAGS="${CFLAGS} -fprofile-arcs -ftest-coverage" LDFLAGS="${LDFLAGS} -fprofile-arcs" ${MAKE} test
	$(QUIET)lcov --directory . --capture --output-file $(PROJECT).info
	$(QUIET)genhtml --output-directory gcov $(PROJECT).info

test: ${PROJECT}
	$(QUIET)${MAKE} -C tests run

test-debug: debug
	$(QUIET)${MAKE} -C tests run-debug

dist: clean
	$(QUIET)tar -czf $(TARFILE) --exclude=.gitignore \
		--transform 's,^,$(PROJECTNV)-$(VERSION)/,' \
		`git ls-files`

${PROJECT}.pc: ${PROJECTNV}.pc.in config.mk
	$(QUIET)sed -e 's,@PROJECT@,${PROJECT},' \
		-e 's,@VERSION@,${VERSION},' \
		-e 's,@INCLUDEDIR@,${INCLUDEDIR},' \
		-e 's,@LIBDIR@,${LIBDIR},' \
		-e 's,@LIBNOTIFY_PC_NAME@,${LIBNOTIFY_PC_NAME},' \
		${PROJECTNV}.pc.in > ${PROJECT}.pc.tmp
	$(QUIET)mv ${PROJECT}.pc.tmp ${PROJECT}.pc

po:
	$(QUIET)${MAKE} -C po

update-po:
	$(QUIET)${MAKE} -C po update-po

install-static: static
	$(call colorecho,INSTALL,"Install static library")
	$(QUIET)mkdir -m 755 -p ${DESTDIR}${LIBDIR}
	$(QUIET)install -m 644 lib${PROJECT}.a ${DESTDIR}${LIBDIR}

install-shared: shared
	$(call colorecho,INSTALL,"Install shared library")
	$(QUIET)mkdir -m 755 -p ${DESTDIR}${LIBDIR}
	$(QUIET)install -m 644 lib${PROJECT}.so.${SOVERSION} ${DESTDIR}${LIBDIR}
	$(QUIET)ln -sf lib${PROJECT}.so.${SOVERSION} ${DESTDIR}${LIBDIR}/lib${PROJECT}.so.${SOMAJOR} || \
		echo "Failed to create lib${PROJECT}.so.${SOMAJOR}. Please check if it exists and points to the correct version of lib${PROJECT}.so."
	$(QUIET)ln -sf lib${PROJECT}.so.${SOVERSION} ${DESTDIR}${LIBDIR}/lib${PROJECT}.so || \
		echo "Failed to create lib${PROJECT}.so. Please check if it exists and points to the correct version of lib${PROJECT}.so."

install: options po install-static install-shared install-headers
		$(QUIET)${MAKE} -C po install

install-headers: version.h ${PROJECT}.pc
	$(call colorecho,INSTALL,"Install pkg-config file")
	$(QUIET)mkdir -m 755 -p ${DESTDIR}${LIBDIR}/pkgconfig
	$(QUIET)install -m 644 ${PROJECT}.pc ${DESTDIR}${LIBDIR}/pkgconfig
	$(call colorecho,INSTALL,"Install header files")
	$(QUIET)mkdir -m 755 -p ${DESTDIR}${INCLUDEDIR}/girara
	$(QUIET)install -m 644 ${HEADERS_INSTALL} ${DESTDIR}${INCLUDEDIR}/girara

uninstall: uninstall-headers
	$(call colorecho,UNINSTALL,"Remove library files")
	$(QUIET)rm -f ${LIBDIR}/lib${PROJECT}.a ${LIBDIR}/lib${PROJECT}.so.${SOVERSION} \
		${LIBDIR}/lib${PROJECT}.so.${SOMAJOR} ${LIBDIR}/lib${PROJECT}.so
	$(QUIET)${MAKE} -C po uninstall

uninstall-headers:
	$(call colorecho,UNINSTALL,"Remove header files")
	$(QUIET)rm -rf ${INCLUDEDIR}/girara
	$(call colorecho,UNINSTALL,"Remove pkg-config file")
	$(QUIET)rm -f ${LIBDIR}/pkgconfig/${PROJECT}.pc

.PHONY: all options clean debug doc test dist install install-headers uninstall \
	uninstall-headers ${PROJECT} ${PROJECT}-debug po update-po \
	static shared install-static install-shared

TDEPENDS = ${OBJECTS:.o=.o.dep}
DEPENDS = ${TDEPENDS:^=.depend/}
-include ${DEPENDS}

=== po/Makefile ===
# See LICENSE file for license and copyright information

include ../config.mk
include ../common.mk
include ../colors.mk

PROJECTNV  = girara
PROJECT    = girara-gtk3
CATALOGS   = $(wildcard *.po)
LINGUAS   ?= $(patsubst %.po, %, $(CATALOGS))
ifeq ($(LINGUAS),)
ALINGUAS   =
else
ALINGUAS   = $(shell find $(patsubst %, %.po, $(LINGUAS)) 2>/dev/null)
endif
MOS = $(patsubst %, %/LC_MESSAGES/${GETTEXT_PACKAGE}.mo, $(patsubst %.po, %, $(ALINGUAS)))

all: ${MOS}

clean:
	$(QUIET)rm -rf POTFILES.in POTFILES.in.tmp $(patsubst %.po, %, $(CATALOGS)) ${PROJECT}.pot

POTFILES.in: $(wildcard ../*.c)
	$(QUIET) set -e && rm -f $@.tmp && touch $@.tmp && \
	for f in $(^F) ; do \
		echo $$f >> $@.tmp ; \
	done && \
	mv $@.tmp $@

${GETTEXT_PACKAGE}.pot: POTFILES.in
	$(ECHO) regenerate $@
	$(QUIET)intltool-update --pot --gettext-package=${GETTEXT_PACKAGE}

update-po: ${GETTEXT_PACKAGE}.pot
	$(call colorecho,PO,"Updating po files ${CATALOGS}")
	$(QUIET)set -e && for f in ${CATALOGS} ; do \
		intltool-update --dist --gettext-package=${GETTEXT_PACKAGE} `echo $$f | sed 's/\.po//'` ; \
		sed -i 's/Report-Msgid-Bugs-To: \\n/Report-Msgid-Bugs-To: http:\/\/bugs.pwmt.org\\n/'  "$$f" ; \
	done

%/LC_MESSAGES/${GETTEXT_PACKAGE}.mo: %.po
	@mkdir -p $(@D)
	$(call colorecho,MSGFMT,$(shell echo $< | sed 's/\.po//'))
	$(QUIET)${MSGFMT} ${MSGFMTFLAGS} -c $< -o $@

install: ${MOS}
	$(call colorecho,INSTALL,"Install translations")
	$(QUIET)set -e && for f in $^ ; do \
		mkdir -p -m 755 $(DESTDIR)$(LOCALEDIR)/`dirname $$f`; \
		install -m 644 $$f $(DESTDIR)$(LOCALEDIR)/`dirname $$f` ; \
	done

uninstall: ${MOS}
	$(call colorecho,UNINSTALL,"Uninstall translations")
	$(QUIET)set -e && for f in $^ ; do \
		rm -f $(LOCALEDIR)/$$f; \
	done

.PHONY: all clean install uninstall update-po

=== tests/Makefile ===
# See LICENSE file for license and copyright information

include ../config.mk
include ../common.mk
include ../colors.mk

include config.mk

SOURCE   = tests.c $(wildcard test_*.c)
OBJECTS  = ${SOURCE:.c=.o}
DOBJECTS = ${SOURCE:.c=.do}
XDG_HELPER_SOURCE = xdg_test_helper.c
XDG_HELPER = ${XDG_HELPER_SOURCE:.c=}

all: options girara_test ${XDG_HELPER}

run: girara_test ${XDG_HELPER}
	$(ECHO) "running tests ..."
	$(QUIET)G_SLICE=debug-blocks ./girara_test

debug: options girara_test-debug ${XDG_HELPER}

run-debug: debug
	$(ECHO) "running tests ..."
	$(QUIET)G_SLICE=debug-blocks ./girara_test-debug

options:
	@echo ${PROJECT} build options:
	@echo "CFLAGS  = ${CFLAGS}"
	@echo "LDFLAGS = ${LDFLAGS}"
	@echo "DFLAGS  = ${DFLAGS}"
	@echo "CC      = ${CC}"

%.o: %.c
	@mkdir -p .depend
	$(call colorecho,CC,$<)
	$(QUIET)${CC} -c -I.. ${CPPFLAGS} ${CFLAGS} -o $@ $< -MMD -MF .depend/$@.dep

${XDG_HELPER}: ${XDG_HELPER_SOURCE} ../libgirara-gtk3.a
	@mkdir -p .depend
	$(call colorecho,CC,$<)
	$(QUIET)${CC}  -I.. ${CPPFLAGS} ${CFLAGS} -o $@ $< ../libgirara-gtk3.a ${LDFLAGS} ${LIBS} -MMD -MF .depend/$@.dep

%.do: %.c
	@mkdir -p .depend
	$(call colorecho,CC,$<)
	$(QUIET)${CC} -c -I.. ${CPPFLAGS} ${CFLAGS} ${DFLAGS} -o $@ $< -MMD -MF .depend/$@.dep

girara_test: ${OBJECTS} ../libgirara-gtk3.a
	$(call colorecho,LD,$@)
	$(QUIET)${CC} ${LDFLAGS} -o $@ ${OBJECTS} ../libgirara-gtk3.a ${LIBS}

girara_test-debug: ${DOBJECTS} ../libgirara-gtk3-debug.a
	$(call colorecho,LD,$@)
	$(QUIET)${CC} ${LDFLAGS} -o $@ ${DOBJECTS} ../libgirara-gtk3-debug.a ${LIBS}

${DOBJECTS} ${OBJECTS}: ../config.mk

clean:
	$(QUIET)rm -rf ${OBJECTS} ${DOBJECTS} girara_test \
		girara_test-debug .depend ${XDG_HELPER} *gcda *gcno

.PHONY: all options clean debug run run-debug

-include $(wildcard .depend/*.dep)

=== debian/changelog ===
girara (0.2.2-3) unstable; urgency=medium

  * debian/patches/disable-background-image.patch: Upstream patch to disable
    background image and fix various issues if Adwaita is used as GTK+ theme.

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 26 Jul 2014 10:24:19 +0200

girara (0.2.2-2) unstable; urgency=medium

  * debian/patches/hide-resize-grip.patch: Upstream patch to really hide
    resize grip.

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 01 Jul 2014 13:27:16 +0200

girara (0.2.2-1) unstable; urgency=medium

  * New upstream release.
    - Switch to CSS based theming which makes the scrollbar settings work
      again with GTK+ 3.4. (Closes: #735873)
  * debian/libgirara-gtk3-1.symbols: Add new symbols.
  * debian/patches/hide-CSS_TEMPLATE.patch: Mark CSS_TEMPLATE as hidden. It
    should not be part of the ABI.
  * debian/control:
    - Build-Depends-Indep: Add graphviz for dot which is required by doxygen.
    - Add libnotify-dev to Build-Depends and libgirara-dev's Depends to enable
      libnotify support.

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 25 Jun 2014 13:19:55 +0200

girara (0.2.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright: Update copyright years.
  * debian/patches: Removed, no longer needed.

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 17 Feb 2014 17:01:33 +0100

=== debian/control ===
Source: girara
Section: libs
Priority: optional
Maintainer: Sebastian Ramacher <sramacher@debian.org>
Build-Depends:
 check,
 debhelper (>= 9),
 libgtk-3-dev,
 libnotify-dev,
 pkg-config,
 gettext,
 xauth,
 xvfb
Build-Depends-Indep:
 doxygen,
 graphviz
Standards-Version: 3.9.5
Homepage: http://pwmt.org/projects/girara/

Package: libgirara-gtk3-1
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 xdg-utils,
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 libgirara-dbg (= ${binary:Version})
Breaks:
 libgirara-dbg (<< ${binary:Version})
Description: library for minimalistic user interfaces (shared libraries, GTK+ 3)
 A library focused at implementing minimalistic user interfaces. It provides
 three main components: a view widget that represents the actual application,
 an input bar to execute application specific commands and a status bar which
 provides information to the user.
 .
 This package contains the shared libraries linked against GTK+ 3.

Package: libgirara-dbg
Architecture: any
Section: debug
Multi-Arch: same
Priority: extra
Depends:
 libgirara-gtk3-1 (= ${binary:Version}),
 ${misc:Depends}
Description: library for minimalistic user interfaces (debugging symbols)
 A library focused at implementing minimalistic user interfaces. It provides
 three main components: a view widget that represents the actual application,
 an input bar to execute application specific commands and a status bar which
 provides information to the user.
 .
 This package contains the debugging symbols for the shared library.

Package: libgirara-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends:
 libgirara-gtk3-1 (= ${binary:Version}),
 libgtk-3-dev,
 libnotify-dev,
 ${misc:Depends}
Suggests:
 libgirara-doc (= ${source:Version})
Breaks:
 zathura-dev (<< 0.2.5-1)
Description: library for minimalistic user interfaces (development files)
 A library focused at implementing minimalistic user interfaces. It provides
 three main components: a view widget that represents the actual application,
 an input bar to execute application specific commands and a status bar which
 provides information to the user.
 .
 This package contains the development files.

Package: libgirara-doc
Architecture: all
Section: doc
Multi-Arch: foreign
Depends:
 libjs-jquery,
 ${misc:Depends}
Description: library for minimalistic user interfaces (documentation)
 A library focused at implementing minimalistic user interfaces. It provides
 three main components: a view widget that represents the actual application,
 an input bar to execute application specific commands and a status bar which
 provides information to the user.
 .
 This package contains the documentation.

## girara 0.2.3

=== debian/changelog ===
girara (0.2.3-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches: Drop all patches, no longer needed.
  * debian/rules: Disable colors in build output.
  * debian/control: Bump Standards-Version to 3.9.6.
  * debian/libgirara-gtk3-1.symbols: Add new symbols.

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 17 Oct 2014 02:28:50 +0200

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
 Build-Depends-Indep:
  doxygen,
  graphviz
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://pwmt.org/projects/girara/
 
 Package: libgirara-gtk3-1

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed

# do not strip
export SFLAGS=
# build with verbose output
export VERBOSE=1
# install into multiarch libdir
export LIBDIR=/usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
# disable check's timeout funtionality
export CK_DEFAULT_TIMEOUT=0
# use little endian mo files everywhere
export MSGFMTFLAGS=--endianness little
# do not use colors
export COLOR=0

%:
	dh $@ --parallel

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	xvfb-run -a $(MAKE) test
endif

override_dh_strip:
	dh_strip --dbg-package=libgirara-dbg

override_dh_auto_build-indep:
	# build documentation if doxygen is available and remove the copy of jquery
	# and replace it with the one from libjs-jquery
ifneq "$(wildcard /usr/bin/doxygen)" ""
	$(MAKE) doc
	rm -f doc/html/installdox
	rm doc/html/jquery.js
	ln -s /usr/share/javascript/jquery/jquery.js doc/html/jquery.js
endif

override_dh_auto_test-indep override_dh_auto_install-indep:
	# no tests and install for indep

## girara 0.2.4

=== debian/changelog ===
girara (0.2.4-3) unstable; urgency=medium

  * Upload to unstable.

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 25 Apr 2015 10:57:48 +0200

girara (0.2.4-2) experimental; urgency=medium

  * debian/control: Add libjson-c-dev to {,Build-}Depends.

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 14 Apr 2015 18:50:04 +0200

girara (0.2.4-1) experimental; urgency=medium

  * New upstream release.
  * SONAME bump.
    - debian/control: Rename libgirara-gtk3-1 to libgirara-gtk3-2.
    - debian/libgirara-gtk3-2.symbols: Remove dropped symbols.
  * debian/{libgirara-doc.docs,rules}: Fix doc building.
  * debian/copyright: Update copyright years.

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 14 Apr 2015 04:23:50 +0200

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
  debhelper (>= 9),
  libgtk-3-dev,
  libnotify-dev,
+ libjson-c-dev,
  pkg-config,
  gettext,
  xauth,
@@ -17,7 +18,7 @@
 Standards-Version: 3.9.6
 Homepage: http://pwmt.org/projects/girara/
 
-Package: libgirara-gtk3-1
+Package: libgirara-gtk3-2
 Architecture: any
 Multi-Arch: same
 Pre-Depends:
@@ -44,7 +45,7 @@
 Multi-Arch: same
 Priority: extra
 Depends:
- libgirara-gtk3-1 (= ${binary:Version}),
+ libgirara-gtk3-2 (= ${binary:Version}),
  ${misc:Depends}
 Description: library for minimalistic user interfaces (debugging symbols)
  A library focused at implementing minimalistic user interfaces. It provides
@@ -59,9 +60,10 @@
 Section: libdevel
 Multi-Arch: same
 Depends:
- libgirara-gtk3-1 (= ${binary:Version}),
+ libgirara-gtk3-2 (= ${binary:Version}),
  libgtk-3-dev,
  libnotify-dev,
+ libjson-c-dev,
  ${misc:Depends}
 Suggests:
  libgirara-doc (= ${source:Version})

=== debian/rules ===
--- 
+++ 
@@ -32,9 +32,9 @@
 	# and replace it with the one from libjs-jquery
 ifneq "$(wildcard /usr/bin/doxygen)" ""
 	$(MAKE) doc
-	rm -f doc/html/installdox
-	rm doc/html/jquery.js
-	ln -s /usr/share/javascript/jquery/jquery.js doc/html/jquery.js
+	find doc/build/html -name *.md5 -delete
+	rm -f doc/build/html/jquery.js
+	ln -s /usr/share/javascript/jquery/jquery.js doc/build/html/jquery.js
 endif
 
 override_dh_auto_test-indep override_dh_auto_install-indep:

## girara 0.2.5

=== Makefile ===
# See LICENSE file for license and copyright information

include config.mk
include colors.mk
include common.mk

PROJECTNV     = girara
PROJECT       = girara-gtk3

SOURCE        = $(wildcard ${PROJECTNV}/*.c)
CSOURCE       = $(filter-out ${PROJECTNV}/css-definitions.c, ${SOURCE})

OBJECTS       = $(addprefix ${BUILDDIR_RELEASE}/,${CSOURCE:.c=.o}) \
	${BUILDDIR_RELEASE}/${PROJECTNV}/css-definitions.o
OBJECTS_DEBUG = $(addprefix ${BUILDDIR_DEBUG}/,${CSOURCE:.c=.o}) \
	${BUILDDIR_DEBUG}/${PROJECTNV}/css-definitions.o
OBJECTS_GCOV  = $(addprefix ${BUILDDIR_GCOV}/,${CSOURCE:.c=.o}) \
	${BUILDDIR_GCOV}/${PROJECTNV}/css-definitions.o

HEADERS       = $(filter-out ${PROJECTNV}/internal.h, $(wildcard ${PROJECTNV}/*.h))

ifneq (${WITH_LIBNOTIFY},0)
CPPFLAGS += -DWITH_LIBNOTIFY
LIBNOTIFY_PC_NAME = libnotify
else
LIBNOTIFY_PC_NAME =
endif

ifneq (${WITH_JSON},0)
CPPFLAGS += -DWITH_JSON
JSON_PC_NAME = json-c
else
JSON_PC_NAME =
endif

ifeq (,$(findstring -DGETTEXT_PACKAGE,${CPPFLAGS}))
CPPFLAGS += -DGETTEXT_PACKAGE=\"${GETTEXT_PACKAGE}\"
endif
ifeq (,$(findstring -DLOCALEDIR,${CPPFLAGS}))
CPPFLAGS += -DLOCALEDIR=\"${LOCALEDIR}\"
endif

UNAME := $(shell uname -s)
ifeq ($(UNAME), Darwin)
SONAME_FLAG = -install_name
SHARED_FLAG = -dynamiclib
endif

all: ${PROJECTNV} ${BUILDDIR}/${PROJECT}.pc po

# pkg-config based version checks
.version-checks/%: config.mk
	$(QUIET)test $($(*)_VERSION_CHECK) -eq 0 || \
		${PKG_CONFIG} --atleast-version $($(*)_MIN_VERSION) $($(*)_PKG_CONFIG_NAME) || ( \
		echo "The minimum required version of $(*) is $($(*)_MIN_VERSION)" && \
		false \
	)
	@mkdir -p .version-checks
	$(QUIET)touch $@

options:
	@echo ${PROJECTNV} build options:
	@echo "CFLAGS  = ${CFLAGS}"
	@echo "LDFLAGS = ${LDFLAGS}"
	@echo "DFLAGS  = ${DFLAGS}"
	@echo "CC      = ${CC}"

# generated files

${PROJECTNV}/version.h: ${PROJECTNV}/version.h.in config.mk
	$(call colorecho,GEN,$@)
	$(QUIET)sed \
		-e 's,@GVMAJOR@,${GIRARA_VERSION_MAJOR},' \
		-e 's,@GVMINOR@,${GIRARA_VERSION_MINOR},' \
		-e 's,@GVREV@,${GIRARA_VERSION_REV},' \
		${PROJECTNV}/version.h.in > ${PROJECTNV}/version.h.tmp
	$(QUIET)mv ${PROJECTNV}/version.h.tmp ${PROJECTNV}/version.h

${PROJECTNV}/css-definitions.c: data/girara.css_t
	$(call colorecho,GEN,$@)
	$(QUIET)echo '#include "css-definitions.h"' > $@.tmp
	$(QUIET)echo 'const char* CSS_TEMPLATE =' >> $@.tmp
	$(QUIET)sed 's/^\(.*\)$$/"\1\\n"/' $< >> $@.tmp
	$(QUIET)echo ';' >> $@.tmp
	$(QUIET)mv $@.tmp $@

${BUILDDIR}/${PROJECT}.pc: ${PROJECTNV}.pc.in config.mk
	$(call colorecho,GEN,$(shell basename $@))
	@mkdir -p ${BUILDDIR}
	$(QUIET)sed -e 's,@PROJECT@,${PROJECT},' \
		-e 's,@VERSION@,${VERSION},' \
		-e 's,@INCLUDEDIR@,${INCLUDEDIR},' \
		-e 's,@LIBDIR@,${LIBDIR},' \
		-e 's,@LIBNOTIFY_PC_NAME@,${LIBNOTIFY_PC_NAME},' \
		-e 's,@JSON_PC_NAME@,${JSON_PC_NAME},' \
		${PROJECTNV}.pc.in > $@.tmp
	$(QUIET)mv $@.tmp $@

# release build

${OBJECTS}: config.mk \
	${PROJECTNV}/version.h \
	.version-checks/GTK \
	.version-checks/GLIB

${BUILDDIR_RELEASE}/%.o: %.c
	$(call colorecho,CC,$<)
	@mkdir -p ${DEPENDDIR}/$(dir $@)
	@mkdir -p $(dir $(abspath $@))
	$(QUIET)${CC} -c ${CPPFLAGS} ${CFLAGS} -o $@ $< \
		-MMD -MF ${DEPENDDIR}/$@.dep

${BUILDDIR_RELEASE}/${BINDIR}/lib${PROJECT}.a: ${OBJECTS}
	$(call colorecho,AR,$@)
	@mkdir -p ${BUILDDIR_RELEASE}/${BINDIR}
	$(QUIET)${AR} rcs $@ ${OBJECTS}

${BUILDDIR_RELEASE}/${BINDIR}/lib${PROJECT}.so.${SOVERSION}: ${OBJECTS}
	$(call colorecho,LD,$@)
	@mkdir -p ${BUILDDIR_RELEASE}/${BINDIR}
	$(QUIET)${CC} -Wl,${SONAME_FLAG},lib${PROJECT}.so.${SOMAJOR} \
		${SHARED_FLAG} ${LDFLAGS} -o $@ ${OBJECTS} ${LIBS}

${PROJECT}: static shared
${PROJECTNV}: ${PROJECT}
static: ${BUILDDIR_RELEASE}/${BINDIR}/lib${PROJECT}.a
shared: ${BUILDDIR_RELEASE}/${BINDIR}/lib${PROJECT}.so.${SOVERSION}
release: ${PROJECT}

# debug build

${OBJECT_DEBUG}: config.mk \
	${PROJECTNV}/version.h \
	.version-checks/GTK \
	.version-checks/GLIB

${BUILDDIR_DEBUG}/%.o: %.c
	$(call colorecho,CC,$<)
	@mkdir -p ${DEPENDDIR}/$(dir $@)
	@mkdir -p $(dir $(abspath $@))
	$(QUIET)${CC} -c ${CPPFLAGS} ${CFLAGS} ${DFLAGS} -o $@ $< \
		-MMD -MF ${DEPENDDIR}/$@.dep

${BUILDDIR_DEBUG}/${BINDIR}/lib${PROJECT}.a: ${OBJECTS_DEBUG}
	$(call colorecho,AR,$@)
	@mkdir -p ${BUILDDIR_DEBUG}/${BINDIR}
	$(QUIET)${AR} rcs $@ ${OBJECTS_DEBUG}

${BUILDDIR_DEBUG}/${BINDIR}/lib${PROJECT}.so.${SOVERSION}: ${OBJECTS_DEBUG}
	$(call colorecho,LD,$@)
	@mkdir -p ${BUILDDIR_DEBUG}/${BINDIR}
	$(QUIET)${CC} -Wl,${SONAME_FLAG},lib${PROJECT}.so.${SOMAJOR} ${SHARED_FLAG} ${LDFLAGS} -o $@ ${OBJECTS_DEBUG} ${LIBS}

${PROJECT}-debug: \
	${BUILDDIR_DEBUG}/${BINDIR}/lib${PROJECT}.a \
	${BUILDDIR_DEBUG}/${BINDIR}/lib${PROJECT}.so.${SOVERSION}
debug: ${PROJECT}-debug

# gcov build

${OBJECTS_GCOV}: config.mk \
	${PROJECTNV}/version.h \
	.version-checks/GLIB \
	.version-checks/GTK

${BUILDDIR_GCOV}/%.o: %.c
	$(call colorecho,CC,$<)
	@mkdir -p ${DEPENDDIR}/$(dir $@)
	@mkdir -p $(dir $(abspath $@))
	$(QUIET)${CC} -c ${CPPFLAGS} ${CFLAGS} ${GCOV_CFLAGS} \
		-o $@ $< -MMD -MF ${DEPENDDIR}/$@.dep

${BUILDDIR_GCOV}/${BINDIR}/lib${PROJECT}.a: ${OBJECTS_GCOV}
	$(call colorecho,AR,$@)
	@mkdir -p ${BUILDDIR_GCOV}/${BINDIR}
	$(QUIET)${AR} rcs $@ ${OBJECTS_GCOV}

${BUILDDIR_GCOV}/${BINDIR}/lib${PROJECT}.so.${SOVERSION}: ${OBJECTS_GCOV}
	$(call colorecho,LD,$@)
	@mkdir -p ${BUILDDIR_GCOV}/${BINDIR}
	$(QUIET)${CC} -Wl,${SONAME_FLAG},lib${PROJECT}.so.${SOMAJOR} ${SHARED_FLAG} \
		${GCOV_LDFLAGS} -o $@ ${OBJECTS_GCOV} ${LIBS}

${PROJECT}-gcov: ${BUILDDIR_GCOV}/${BINDIR}/lib${PROJECT}.a
gcov: ${PROJECT}-gcov

run-gcov: options gcov
	$(QUIET)${MAKE} -C tests run-gcov
	$(call colorecho,LCOV,"Analyse data")
	$(QUIET)${LCOV_EXEC} ${LCOV_FLAGS}
	$(call colorecho,LCOV,"Generate report")
	$(QUIET)${GENHTML_EXEC} ${GENHTML_FLAGS}

# clean

clean:
	$(QUIET)rm -rf \
		${BUILDDIR} \
		${DEPENDDIR} \
		${TARFILE} \
		${GCDA} \
		${GCNO} \
		$(PROJECT).info \
		gcov \
		.version-checks \
		${PROJECTNV}/version.h \
		${PROJECTNV}/version.h.tmp \
		${PROJECTNV}/css-definitions.c \
		${PROJECTNV}/css-definitions.c.tmp
	$(QUIET)$(MAKE) -C tests clean
	$(QUIET)$(MAKE) -C po clean
	$(QUIET)$(MAKE) -C doc clean

# translations

po:
	$(QUIET)${MAKE} -C po

update-po:
	$(QUIET)${MAKE} -C po update-po

# documentation

doc:
	$(QUIET)$(MAKE) -C doc

# tests

test: ${PROJECT}
	$(QUIET)$(MAKE) -C tests run

test-debug: ${PROJECT}-debug
	$(QUIET)$(MAKE) -C tests run-debug

# create taball

dist:
	$(QUIET)tar -czf $(TARFILE) --exclude=.gitignore \
		--transform 's,^,$(PROJECTNV)-$(VERSION)/,' \
		`git ls-files`

# install

install-static: static
	$(call colorecho,INSTALL,"Install static library")
	$(QUIET)mkdir -m 755 -p ${DESTDIR}${LIBDIR}
	$(QUIET)install -m 644 ${BUILDDIR_RELEASE}/${BINDIR}/lib${PROJECT}.a ${DESTDIR}${LIBDIR}

install-shared: shared
	$(call colorecho,INSTALL,"Install shared library")
	$(QUIET)mkdir -m 755 -p ${DESTDIR}${LIBDIR}
	$(QUIET)install -m 644 ${BUILDDIR_RELEASE}/${BINDIR}/lib${PROJECT}.so.${SOVERSION} ${DESTDIR}${LIBDIR}
	$(QUIET)ln -sf lib${PROJECT}.so.${SOVERSION} ${DESTDIR}${LIBDIR}/lib${PROJECT}.so.${SOMAJOR} || \
		echo "Failed to create lib${PROJECT}.so.${SOMAJOR}. Please check if it exists and points to the correct version of lib${PROJECT}.so."
	$(QUIET)ln -sf lib${PROJECT}.so.${SOVERSION} ${DESTDIR}${LIBDIR}/lib${PROJECT}.so || \
		echo "Failed to create lib${PROJECT}.so. Please check if it exists and points to the correct version of lib${PROJECT}.so."

install-headers: ${PROJECTNV}/version.h ${BUILDDIR}/${PROJECT}.pc
	$(call colorecho,INSTALL,"Install pkg-config file")
	$(QUIET)mkdir -m 755 -p ${DESTDIR}${LIBDIR}/pkgconfig
	$(QUIET)install -m 644 ${BUILDDIR}/${PROJECT}.pc ${DESTDIR}${LIBDIR}/pkgconfig
	$(call colorecho,INSTALL,"Install header files")
	$(QUIET)mkdir -m 755 -p ${DESTDIR}${INCLUDEDIR}/girara
	$(QUIET)install -m 644 ${HEADERS} ${DESTDIR}${INCLUDEDIR}/girara

install-po:
	$(QUIET)${MAKE} -C po install

install: install-po install-static install-shared install-headers

# uninstall

uninstall: uninstall-headers
	$(call colorecho,UNINSTALL,"Remove library files")
	$(QUIET)rm -f ${LIBDIR}/lib${PROJECT}.a ${LIBDIR}/lib${PROJECT}.so.${SOVERSION} \
		${LIBDIR}/lib${PROJECT}.so.${SOMAJOR} ${LIBDIR}/lib${PROJECT}.so
	$(QUIET)${MAKE} -C po uninstall

uninstall-headers:
	$(call colorecho,UNINSTALL,"Remove header files")
	$(QUIET)rm -rf ${DESTDIR}${INCLUDEDIR}/girara
	$(call colorecho,UNINSTALL,"Remove pkg-config file")
	$(QUIET)rm -f ${DESTDIR}${LIBDIR}/pkgconfig/${PROJECT}.pc

DEPENDS = ${DEPENDDIRS:^=${DEPENDDIR}/}$(addprefix ${DEPENDDIR}/,${OBJECTS:.o=.o.dep})
-include ${DEPENDS}

.PHONY: all options clean debug doc test dist install install-headers uninstall \
	uninstall-headers ${PROJECT} ${PROJECT}-debug po update-po \
	static shared install-static install-shared

=== debian/changelog ===
girara (0.2.5-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    - Update libgtk-3-dev in (Build-)Depends to (>= 3.4).
    - Remove obsolete Pre-Depends and Breaks.
    - Add Vcs-* fields.
  * debian/libgirara-gtk3-2.symbols: Add new symbol.
  * Migrate to automatic dbg packages.
    - debian/control:
      + Bump Build-Depends on debhelper to (>= 9.20151219).
      + Remove libgirara-dbg.
    - debian/rules: Run dh_strip with --ddeb-migration.

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 21 Dec 2015 14:07:08 +0100

=== debian/control ===
Source: girara
Section: libs
Priority: optional
Maintainer: Sebastian Ramacher <sramacher@debian.org>
Build-Depends:
 check,
 debhelper (>= 9.20151219),
 libgtk-3-dev (>= 3.4),
 libnotify-dev,
 libjson-c-dev,
 pkg-config,
 gettext,
 xauth,
 xvfb
Build-Depends-Indep:
 doxygen,
 graphviz
Standards-Version: 3.9.6
Vcs-Git: git://anonscm.debian.org/collab-maint/girara.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/girara.git
Homepage: http://pwmt.org/projects/girara/

Package: libgirara-gtk3-2
Architecture: any
Multi-Arch: same
Depends:
 xdg-utils,
 ${misc:Depends},
 ${shlibs:Depends}
Description: library for minimalistic user interfaces (shared libraries, GTK+ 3)
 A library focused at implementing minimalistic user interfaces. It provides
 three main components: a view widget that represents the actual application,
 an input bar to execute application specific commands and a status bar which
 provides information to the user.
 .
 This package contains the shared libraries linked against GTK+ 3.

Package: libgirara-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends:
 libgirara-gtk3-2 (= ${binary:Version}),
 libgtk-3-dev (>= 3.4),
 libnotify-dev,
 libjson-c-dev,
 ${misc:Depends}
Suggests:
 libgirara-doc (= ${source:Version})
Description: library for minimalistic user interfaces (development files)
 A library focused at implementing minimalistic user interfaces. It provides
 three main components: a view widget that represents the actual application,
 an input bar to execute application specific commands and a status bar which
 provides information to the user.
 .
 This package contains the development files.

Package: libgirara-doc
Architecture: all
Section: doc
Multi-Arch: foreign
Depends:
 libjs-jquery,
 ${misc:Depends}
Description: library for minimalistic user interfaces (documentation)
 A library focused at implementing minimalistic user interfaces. It provides
 three main components: a view widget that represents the actual application,
 an input bar to execute application specific commands and a status bar which
 provides information to the user.
 .
 This package contains the documentation.

=== debian/rules ===
--- 
+++ 
@@ -25,7 +25,7 @@
 endif
 
 override_dh_strip:
-	dh_strip --dbg-package=libgirara-dbg
+	dh_strip --ddeb-migration='libgirara-dbg (<< 0.2.5-1~)'
 
 override_dh_auto_build-indep:
 	# build documentation if doxygen is available and remove the copy of jquery

## girara 0.2.6

=== debian/changelog ===
girara (0.2.6-1build1) yakkety; urgency=medium

  * Rebuild against libjson-c3.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 28 Apr 2016 00:04:19 +0200

girara (0.2.6-1) unstable; urgency=medium

  * New upstream release.
  * debian/contro:
    - Bump Standards-Version.
    - Update Vcs-*.
  * debian/rules: Remove dh_strip override.

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 18 Apr 2016 23:23:29 +0200

=== debian/control ===
--- 
+++ 
@@ -15,8 +15,8 @@
 Build-Depends-Indep:
  doxygen,
  graphviz
-Standards-Version: 3.9.6
-Vcs-Git: git://anonscm.debian.org/collab-maint/girara.git
+Standards-Version: 3.9.8
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/girara.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/girara.git
 Homepage: http://pwmt.org/projects/girara/

=== debian/rules ===
--- 
+++ 
@@ -24,9 +24,6 @@
 	xvfb-run -a $(MAKE) test
 endif
 
-override_dh_strip:
-	dh_strip --ddeb-migration='libgirara-dbg (<< 0.2.5-1~)'
-
 override_dh_auto_build-indep:
 	# build documentation if doxygen is available and remove the copy of jquery
 	# and replace it with the one from libjs-jquery

## girara 0.2.7

=== Makefile ===
--- 
+++ 
@@ -7,7 +7,7 @@
 PROJECTNV     = girara
 PROJECT       = girara-gtk3
 
-SOURCE        = $(wildcard ${PROJECTNV}/*.c)
+SOURCE        = $(sort $(wildcard ${PROJECTNV}/*.c))
 CSOURCE       = $(filter-out ${PROJECTNV}/css-definitions.c, ${SOURCE})
 
 OBJECTS       = $(addprefix ${BUILDDIR_RELEASE}/,${CSOURCE:.c=.o}) \
@@ -17,7 +17,7 @@
 OBJECTS_GCOV  = $(addprefix ${BUILDDIR_GCOV}/,${CSOURCE:.c=.o}) \
 	${BUILDDIR_GCOV}/${PROJECTNV}/css-definitions.o
 
-HEADERS       = $(filter-out ${PROJECTNV}/internal.h, $(wildcard ${PROJECTNV}/*.h))
+HEADERS       = $(filter-out ${PROJECTNV}/internal.h, $(sort $(wildcard ${PROJECTNV}/*.h)))
 
 ifneq (${WITH_LIBNOTIFY},0)
 CPPFLAGS += -DWITH_LIBNOTIFY
@@ -44,6 +44,17 @@
 ifeq ($(UNAME), Darwin)
 SONAME_FLAG = -install_name
 SHARED_FLAG = -dynamiclib
+SOFILE = lib${PROJECT}.dylib
+SOVERSIONFILE = lib${PROJECT}.${SOVERSION}.dylib
+SOMAJORFILE = lib${PROJECT}.${SOMAJOR}.dylib
+BUILDSOMAJORFILE = ${LIBDIR}/${SOMAJORFILE}
+PLATFORMFLAGS = -current_version ${SOVERSION} -compatibility_version ${SOMAJOR}
+else
+SOFILE = lib${PROJECT}.so
+SOVERSIONFILE = ${SOFILE}.${SOVERSION}
+SOMAJORFILE = ${SOFILE}.${SOMAJOR}
+BUILDSOMAJORFILE = ${SOMAJORFILE}
+PLATFORMFLAGS =
 endif
 
 all: ${PROJECTNV} ${BUILDDIR}/${PROJECT}.pc po
@@ -60,10 +71,11 @@
 
 options:
 	@echo ${PROJECTNV} build options:
-	@echo "CFLAGS  = ${CFLAGS}"
-	@echo "LDFLAGS = ${LDFLAGS}"
-	@echo "DFLAGS  = ${DFLAGS}"
-	@echo "CC      = ${CC}"
+	@echo "CFLAGS             = ${CFLAGS}"
+	@echo "LDFLAGS            = ${LDFLAGS}"
+	@echo "DFLAGS             = ${DFLAGS}"
+	@echo "CC                 = ${CC}"
+	@echo "PLATFORMFLAGS      = ${PLATFORMFLAGS}"
 
 # generated files
 
@@ -76,12 +88,16 @@
 		${PROJECTNV}/version.h.in > ${PROJECTNV}/version.h.tmp
 	$(QUIET)mv ${PROJECTNV}/version.h.tmp ${PROJECTNV}/version.h
 
-${PROJECTNV}/css-definitions.c: data/girara.css_t
+${PROJECTNV}/css-definitions.c: data/girara-pre-3.20.css_t data/girara-post-3.20.css_t
 	$(call colorecho,GEN,$@)
 	$(QUIET)echo '#include "css-definitions.h"' > $@.tmp
-	$(QUIET)echo 'const char* CSS_TEMPLATE =' >> $@.tmp
-	$(QUIET)sed 's/^\(.*\)$$/"\1\\n"/' $< >> $@.tmp
+	$(QUIET)echo 'const char* CSS_TEMPLATE_PRE_3_20 =' >> $@.tmp
+	$(QUIET)sed 's/^\(.*\)$$/"\1\\n"/' data/girara-pre-3.20.css_t >> $@.tmp
 	$(QUIET)echo ';' >> $@.tmp
+	$(QUIET)echo 'const char* CSS_TEMPLATE_POST_3_20 =' >> $@.tmp
+	$(QUIET)sed 's/^\(.*\)$$/"\1\\n"/' data/girara-post-3.20.css_t >> $@.tmp
+	$(QUIET)echo ';' >> $@.tmp
+
 	$(QUIET)mv $@.tmp $@
 
 ${BUILDDIR}/${PROJECT}.pc: ${PROJECTNV}.pc.in config.mk
@@ -115,16 +131,16 @@
 	@mkdir -p ${BUILDDIR_RELEASE}/${BINDIR}
 	$(QUIET)${AR} rcs $@ ${OBJECTS}
 
-${BUILDDIR_RELEASE}/${BINDIR}/lib${PROJECT}.so.${SOVERSION}: ${OBJECTS}
+${BUILDDIR_RELEASE}/${BINDIR}/${SOVERSIONFILE}: ${OBJECTS}
 	$(call colorecho,LD,$@)
 	@mkdir -p ${BUILDDIR_RELEASE}/${BINDIR}
-	$(QUIET)${CC} -Wl,${SONAME_FLAG},lib${PROJECT}.so.${SOMAJOR} \
-		${SHARED_FLAG} ${LDFLAGS} -o $@ ${OBJECTS} ${LIBS}
+	$(QUIET)${CC} -Wl,${SONAME_FLAG},${BUILDSOMAJORFILE} \
+		${SHARED_FLAG} ${PLATFORMFLAGS} ${LDFLAGS} -o $@ ${OBJECTS} ${LIBS}
 
 ${PROJECT}: static shared
 ${PROJECTNV}: ${PROJECT}
 static: ${BUILDDIR_RELEASE}/${BINDIR}/lib${PROJECT}.a
-shared: ${BUILDDIR_RELEASE}/${BINDIR}/lib${PROJECT}.so.${SOVERSION}
+shared: ${BUILDDIR_RELEASE}/${BINDIR}/${SOVERSIONFILE}
 release: ${PROJECT}
 
 # debug build
@@ -146,14 +162,14 @@
 	@mkdir -p ${BUILDDIR_DEBUG}/${BINDIR}
 	$(QUIET)${AR} rcs $@ ${OBJECTS_DEBUG}
 
-${BUILDDIR_DEBUG}/${BINDIR}/lib${PROJECT}.so.${SOVERSION}: ${OBJECTS_DEBUG}
+${BUILDDIR_DEBUG}/${BINDIR}/${SOVERSIONFILE}: ${OBJECTS_DEBUG}
 	$(call colorecho,LD,$@)
 	@mkdir -p ${BUILDDIR_DEBUG}/${BINDIR}
-	$(QUIET)${CC} -Wl,${SONAME_FLAG},lib${PROJECT}.so.${SOMAJOR} ${SHARED_FLAG} ${LDFLAGS} -o $@ ${OBJECTS_DEBUG} ${LIBS}
+	$(QUIET)${CC} -Wl,${SONAME_FLAG},${BUILDSOMAJORFILE} ${SHARED_FLAG} ${PLATFORMFLAGS} ${LDFLAGS} -o $@ ${OBJECTS_DEBUG} ${LIBS}
 
 ${PROJECT}-debug: \
 	${BUILDDIR_DEBUG}/${BINDIR}/lib${PROJECT}.a \
-	${BUILDDIR_DEBUG}/${BINDIR}/lib${PROJECT}.so.${SOVERSION}
+	${BUILDDIR_DEBUG}/${BINDIR}/${SOVERSIONFILE}
 debug: ${PROJECT}-debug
 
 # gcov build
@@ -175,11 +191,11 @@
 	@mkdir -p ${BUILDDIR_GCOV}/${BINDIR}
 	$(QUIET)${AR} rcs $@ ${OBJECTS_GCOV}
 
-${BUILDDIR_GCOV}/${BINDIR}/lib${PROJECT}.so.${SOVERSION}: ${OBJECTS_GCOV}
+${BUILDDIR_GCOV}/${BINDIR}/${SOVERSIONFILE}: ${OBJECTS_GCOV}
 	$(call colorecho,LD,$@)
 	@mkdir -p ${BUILDDIR_GCOV}/${BINDIR}
-	$(QUIET)${CC} -Wl,${SONAME_FLAG},lib${PROJECT}.so.${SOMAJOR} ${SHARED_FLAG} \
-		${GCOV_LDFLAGS} -o $@ ${OBJECTS_GCOV} ${LIBS}
+	$(QUIET)${CC} -Wl,${SONAME_FLAG},${BUILDSOMAJORFILE} ${SHARED_FLAG} \
+		${PLATFORMFLAGS} ${GCOV_LDFLAGS} -o $@ ${OBJECTS_GCOV} ${LIBS}
 
 ${PROJECT}-gcov: ${BUILDDIR_GCOV}/${BINDIR}/lib${PROJECT}.a
 gcov: ${PROJECT}-gcov
@@ -249,11 +265,11 @@
 install-shared: shared
 	$(call colorecho,INSTALL,"Install shared library")
 	$(QUIET)mkdir -m 755 -p ${DESTDIR}${LIBDIR}
-	$(QUIET)install -m 644 ${BUILDDIR_RELEASE}/${BINDIR}/lib${PROJECT}.so.${SOVERSION} ${DESTDIR}${LIBDIR}
-	$(QUIET)ln -sf lib${PROJECT}.so.${SOVERSION} ${DESTDIR}${LIBDIR}/lib${PROJECT}.so.${SOMAJOR} || \
-		echo "Failed to create lib${PROJECT}.so.${SOMAJOR}. Please check if it exists and points to the correct version of lib${PROJECT}.so."
-	$(QUIET)ln -sf lib${PROJECT}.so.${SOVERSION} ${DESTDIR}${LIBDIR}/lib${PROJECT}.so || \
-		echo "Failed to create lib${PROJECT}.so. Please check if it exists and points to the correct version of lib${PROJECT}.so."
+	$(QUIET)install -m 644 ${BUILDDIR_RELEASE}/${BINDIR}/${SOVERSIONFILE} ${DESTDIR}${LIBDIR}
+	$(QUIET)ln -sf ${SOVERSIONFILE} ${DESTDIR}${LIBDIR}/${SOMAJORFILE} || \
+		echo "Failed to create ${SOMAJORFILE}. Please check if it exists and points to the correct version of ${SOFILE}."
+	$(QUIET)ln -sf ${SOVERSIONFILE} ${DESTDIR}${LIBDIR}/${SOFILE} || \
+		echo "Failed to create ${SOFILE}. Please check if it exists and points to the correct version of ${SOFILE}."
 
 install-headers: ${PROJECTNV}/version.h ${BUILDDIR}/${PROJECT}.pc
 	$(call colorecho,INSTALL,"Install pkg-config file")
@@ -272,8 +288,8 @@
 
 uninstall: uninstall-headers
 	$(call colorecho,UNINSTALL,"Remove library files")
-	$(QUIET)rm -f ${LIBDIR}/lib${PROJECT}.a ${LIBDIR}/lib${PROJECT}.so.${SOVERSION} \
-		${LIBDIR}/lib${PROJECT}.so.${SOMAJOR} ${LIBDIR}/lib${PROJECT}.so
+	$(QUIET)rm -f ${LIBDIR}/lib${PROJECT}.a ${LIBDIR}/${SOVERSIONFILE} \
+		${LIBDIR}/${SOMAJORFILE} ${LIBDIR}/${SOFILE}
 	$(QUIET)${MAKE} -C po uninstall
 
 uninstall-headers:
@@ -282,6 +298,16 @@
 	$(call colorecho,UNINSTALL,"Remove pkg-config file")
 	$(QUIET)rm -f ${DESTDIR}${LIBDIR}/pkgconfig/${PROJECT}.pc
 
+# format and tidy
+
+format:
+	clang-tidy -fix -checks=readability-braces-around-statements \
+		$(SOURCE) -- $(CPPFLAGS) $(CFLAGS)
+	clang-format-3.8 -i $(SOURCE) $(HEADERS)
+
+tidy:
+	clang-tidy $(SOURCE) -- $(CPPFLAGS) $(CFLAGS)
+
 DEPENDS = ${DEPENDDIRS:^=${DEPENDDIR}/}$(addprefix ${DEPENDDIR}/,${OBJECTS:.o=.o.dep})
 -include ${DEPENDS}

=== tests/Makefile ===
# See LICENSE file for license and copyright information

include ../config.mk
include ../common.mk
include ../colors.mk

include config.mk

PROJECT  = test
SOURCE   = tests.c $(wildcard test_*.c)
OBJECTS       = $(addprefix ${BUILDDIR_RELEASE}/,${SOURCE:.c=.o})
OBJECTS_DEBUG = $(addprefix ${BUILDDIR_DEBUG}/,${SOURCE:.c=.o})
OBJECTS_GCOV  = $(addprefix ${BUILDDIR_GCOV}/,${SOURCE:.c=.o})

GIRARA_OBJECTS = $(wildcard ${GIRARA_RELEASE}/*.o)
GIRARA_OBJECTS_DEBUG = $(wildcard ${GIRARA_DEBUG}/*.o)
GIRARA_OBJECTS_GCOV = $(wildcard ${GIRARA_GCOV}/*.o)

XDG_HELPER_SOURCE = xdg_test_helper.c
XDG_HELPER = $(addprefix ${BUILDDIR_RELEASE}/,${XDG_HELPER_SOURCE:.c=})

CPPFLAGS += -I../girara -DXDG_TEST_HELPER=\"${XDG_HELPER}\"

all: release ${XDG_HELPER}

../girara/version.h:
	$(MAKE) -C .. girara/version.h

# release

${OBJECTS}: config.mk ../config.mk ../girara/version.h

${BUILDDIR_RELEASE}/%.o: %.c
	$(call colorecho,CC,$<)
	@mkdir -p ${DEPENDDIR}/$(dir $(abspath $@))
	@mkdir -p $(dir $(abspath $@))
	$(QUIET)${CC} -c ${CPPFLAGS} ${CFLAGS} \
		-o $@ $< -MMD -MF ${DEPENDDIR}/$(abspath $@).dep

${BUILDDIR_RELEASE}/${BINDIR}/${PROJECT}: ${OBJECTS}
	$(QUIET)$(MAKE) -C .. release
	$(call colorecho,CC,$@)
	@mkdir -p ${BUILDDIR_RELEASE}/${BINDIR}
	$(QUIET)${CC} ${SFLAGS} ${LDFLAGS} \
		-o ${BUILDDIR_RELEASE}/${BINDIR}/${PROJECT} \
		${OBJECTS} ${GIRARA_OBJECTS} ${LIBS}

release: ${BUILDDIR_RELEASE}/${BINDIR}/${PROJECT}

run: release ${XDG_HELPER}
	$(QUIET)./${BUILDDIR_RELEASE}/${BINDIR}/${PROJECT}

# debug

${OBJECTS_DEBUG}: config.mk ../config.mk ../girara/version.h

${BUILDDIR_DEBUG}/%.o: %.c
	@mkdir -p ${DEPENDDIR}/$(dir $(abspath $@))
	@mkdir -p $(dir $(abspath $@))
	$(call colorecho,CC,$<)
	$(QUIET)${CC} -c ${CPPFLAGS} ${CFLAGS} ${DFLAGS} \
		-o $@ $< -MMD -MF ${DEPENDDIR}/$(abspath $@).dep

${BUILDDIR_DEBUG}/${BINDIR}/${PROJECT}: ${OBJECTS_DEBUG}
	$(QUIET)$(MAKE) -C .. debug
	$(call colorecho,CC,$@)
	@mkdir -p ${BUILDDIR_DEBUG}/${BINDIR}
	$(QUIET)${CC} ${SFLAGS} ${LDFLAGS} \
		-o ${BUILDDIR_DEBUG}/${BINDIR}/${PROJECT} \
		${OBJECTS} ${GIRARA_OBJECTS_DEBUG} ${LIBS}

debug: ${BUILDDIR_DEBUG}/${BINDIR}/${PROJECT}

run-debug: debug ${XDG_HELPER}
	$(QUIET)./${BUILDDIR_DEBUG}/${BINDIR}/${PROJECT}

# gcov

${OBJECTS_GCOV}: config.mk ../config.mk ../girara/version.h

${BUILDDIR_GCOV}/%.o: %.c
	@mkdir -p ${DEPENDDIR}/$(dir $(abspath $@))
	@mkdir -p $(dir $(abspath $@))
	$(call colorecho,CC,$<)
	$(QUIET)${CC} -c ${CPPFLAGS} ${CFLAGS} ${GCOV_CFLAGS} ${DFLAGS} ${GCOV_DFLAGS} \
		-o $@ $< -MMD -MF ${DEPENDDIR}/$(abspath $@).dep

${BUILDDIR_GCOV}/${BINDIR}/${PROJECT}: ${OBJECTS_GCOV}
	$(QUIET)$(MAKE) -C .. gcov
	$(call colorecho,CC,$@)
	@mkdir -p ${BUILDDIR_GCOV}/${BINDIR}
	$(QUIET)${CC} ${SFLAGS} ${LDFLAGS} ${GCOV_CFLAGS} ${GCOV_LDFLAGS} \
		-o ${BUILDDIR_GCOV}/${BINDIR}/${PROJECT} \
		${OBJECTS} ${GIRARA_OBJECTS_GCOV} ${LIBS}

gcov: ${BUILDDIR_GCOV}/${BINDIR}/${PROJECT}

run-gcov: gcov
	$(QUIET)./${BUILDDIR_GCOV}/${BINDIR}/${PROJECT}

# XDG test helper

${XDG_HELPER}: ${XDG_HELPER_SOURCE}
	$(MAKE) -C .. release
	@mkdir -p ${DEPENDDIR}/$(dir $(abspath $@))
	@mkdir -p $(dir $(abspath $@))
	$(call colorecho,CC,$@)
	$(QUIET)${CC} ${CPPFLAGS} ${CFLAGS} -o $@ $< ${GIRARA_OBJECTS} \
		${LDFLAGS} ${LIBS} -MMD -MF ${DEPENDDIR}/$(abspath $@).dep

clean:
	$(call colorecho,RM, "Clean test files")
	$(QUIET)rm -rf ${PROJECT}
	$(QUIET)rm -rf ${PROJECT}-debug
	$(QUIET)rm -rf ${PROJECT}-gcov
	$(QUIET)rm -rf ${BUILDDIR}
	$(QUIET)rm -rf ${DEPENDDIR}

.PHONY: all clean debug gciv run run-debug run-gcov

-include $(wildcard ${DEPENDDIR}/*.dep)

=== debian/changelog ===
girara (0.2.7-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches: Drop obsolete patches.
  * debian/libgirara-gtk3-2.symbols: Add new symbols.
  * debian/copyright: Update copyright years.

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 11 Jan 2017 23:02:05 +0100

girara (0.2.6-2) unstable; urgency=medium

  * debian/patches/font-gtk3.21.patch: Fix font handling in CSS with Gtk+ 3.21
    and newer. (Closes: #836204)

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 04 Sep 2016 12:33:05 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Sebastian Ramacher <sramacher@debian.org>
 Build-Depends:
  check,
- debhelper (>= 9.20151219),
+ debhelper (>= 10),
  libgtk-3-dev (>= 3.4),
  libnotify-dev,
  libjson-c-dev,

=== debian/rules ===
--- 
+++ 
@@ -17,7 +17,7 @@
 export COLOR=0
 
 %:
-	dh $@ --parallel
+	dh $@
 
 override_dh_auto_test-arch:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
